//-----------------------------------------------------------------------------
// Project            	RenderKit
// Class		G3DSDLCamera
// Creator            	Philippe C.D. Robert
// Maintainer         	Philippe C.D. Robert
// Creation Date      	Sun Jul 16 23:23:46 CEST 2000
//
// Copyright (c) Philippe C.D. Robert
//
// The RenderKit is free software; you can redistribute it and/or modify it 
// under the terms of the GNU General Public License as published by the Free 
// Software Foundation
//
// $Id: G3DSDLCamera.h,v 1.16 2001/07/15 13:56:15 probert Exp $
//-----------------------------------------------------------------------------

#ifndef __G3DSDLCamera_h_INCLUDE
#define __G3DSDLCamera_h_INCLUDE

#import <Foundation/Foundation.h>
#import <GeometryKit/GeometryKit.h>

#include <SDL/SDL.h>

#import <RenderKit/G3DTypes.h>
#import <RenderKit/G3DCamera.h>

#ifdef GNUSTEP
#include <GL/gl.h>
#else
#include <OpenGL/gl.h>
#endif

typedef struct _G3DVisualInfo {
  int red;
  int green;
  int blue;
  int alpha;
  int depthSize;
  int stencilSize;
  int doubleBuffered;
} G3DVisualInfo;

@interface G3DSDLCamera : G3DCamera 
{
  @private
  G3DVisualInfo _colInfo;
}

//-----------------------------------------------------------------------------
// Init methods
//-----------------------------------------------------------------------------

- (id)initWithSize:(NSSize)aSize;
- (id)initWithSize:(NSSize)aSize depth:(int)bpp fullscreen:(BOOL)yn;
- (id)initWithSize:(NSSize)aSize depth:(int)bpp fullscreen:(BOOL)yn visualInfo:(G3DVisualInfo*)visual;

//-----------------------------------------------------------------------------
// callbacks
//-----------------------------------------------------------------------------

- (void)toggleFullscreen;

@end

extern NSString *G3DSDLCameraException;

#endif
